#!/usr/bin/perl -w
#
#use strict;
#use warnings;

BEGIN { 
    
    unshift @INC, dirname($0);

    use File::Basename;
}

use File::Copy;
$myhome = dirname($0);

$lame = "$myhome/lame"; #path to lame encoder.
$ffmpeg = "$myhome/ffmpeg"; #path to ffmpeg encoder.
$mp3cat = "$myhome/mp3cat"; #path to ffmpeg encoder.
$chaptertool = "$myhome/ChapterTool";
#$ffmpeg = 1; #set to 0 if you do not have ffmepg installed.
$text_file = $ARGV[0];
$ffmpeg = $ARGV[1];
$filepath = dirname($text_file);




undef $/;
open (NCX, "<$text_file");
		while (<NCX>) {
			m/<.*title.*>(.+)<\/.*title>/ig;
			$book_title = $1;
			
			m/<meta\s+name="dc:creator"\s+content="(.+)"\s+\/>/gi;
			
			if ($1 eq "") {
			m/<.*creator*>(.+)<\/.*creator>/gi;
			}
			
			$book_creator = $1;
			#print $book_title;
			}
close NCX;
$title_filename = $book_title;
$title_filename  =~ s/ |'|:|\/|!|\?/_/gi;
$book_title  =~ s/'|:|\/|!|\?//gi;
$long_filename = substr($title_filename, 0, 30);

opendir(BIN, $filepath);

while (defined ($file = readdir BIN)) {
#$basename = basename("$dir/$file");
if ("$filepath/$file" =~ m/\.mp3$/i) {
	$mp3_file = "/$file";
	#print "$mp3_file\n";
	$filelist .= "$filepath/$mp3_file ";
}
}

&cat_mp3;

#print "Processing file, please wait...\n";
print `$lame --silent --tl \"$book_title\" --tg 101 test.mp3 $long_filename.mp3 `;

unlink "test.mp3";
$myresults =  "$long_filename.mp3";

if ($ffmpeg == 1) {
$ffmpeg = "$myhome/ffmpeg"; #path to ffmpeg encoder.
`$ffmpeg -i $long_filename.mp3 -title \"$book_title\" -author \"$book_creator\"  $long_filename.m4a`;
rename("$long_filename.m4a","$long_filename.m4b");
unlink "$long_filename.mp3";
$myresults =  "$long_filename.m4b";
	
if (-e "$filepath/chaptertool.xml")
	{ 
		`$chaptertool -x $filepath/chaptertool.xml -a $long_filename.m4b -o $long_filename.m4b`;
	}
}


print $myresults;

#NEW SUB TO MAKE MP3 WE WILL HAVE TO ADD MP3CAT
sub cat_mp3 {


$cmdwrap = "$mp3cat --output=test.mp3 $filelist";
#print "$cmdwrap\n";
print `$cmdwrap`;
#print "Done with mp3cat";
}